// required parameters: pos (array [realpos, rawpos, base]), track
BMS.AG.ML.DynamicViewer.BaseEditor = Ext.extend(Ext.Window, {
//   renderTo: Ext.getBody(), // this throws IE off, but it's Ext default and commenting it out works, strangely
  height: 230,
  width: 390,
  constrain: true,
  shadow: false, // otherwise IE throws error
  initComponent: function()
  {
    this.feat = this.track.getFeatureAt(this.pos[0]);
    var base = this.feat.base, seq = this.feat.seq, pos = this.feat.pos,
        color = { 'A': '00FF00', 'C': '0000FF', 'G': '000000', 'T': 'FF0000' };
    // makes sure refreshing viewer view will close all edit windows
    if(dynamicViewer)
    {
      if(!dynamicViewer.editWins) dynamicViewer.editWins = [];
      dynamicViewer.editWins.push(this);
    }
    // do some preprocessing
    var comp = {};
    if(this.feat.feat)
    {
      var b = this.feat.feat.b;
      for(var i = 0; i < b.length; i++)
        comp[b[i][0]] = b[i][1];
      comp[base] = this.feat.feat.orig[1];
    }
    else comp[base] = 100;
    // now UI elements
    var style = 'padding:2px;font-size:11px;font-family:tahoma,arial,helvetica,sans-serif;';
    var title = {
      layout: 'table',
      border: false,
      layoutConfig: {columns:1},
      defaults: {style:'font-weight:bold;' + style},
      defaultType: 'label',
      items: {text:'Available actions: '}
    };
    var items = [title];
    var pad = {width:12, xtype:'panel',border:false,html:' - '};
    var insert = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:6},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            {width:80, text:'Insert Base(s) '},
            {width:50, xtype:'textfield', id:'iBase',
             validator:function(v){
               if(v.match(/^[ACGT]*$/i)) return true;
               else return "Only A/C/G/T are allowed";
             }},
            {width:40, text:' to the '},
            { width:70, xtype:'combo', editable:false,
              triggerAction: 'all', mode: 'local',
              store: ['Left','Right']
            },
            {xtype:'button',text:'Insert Now',scope:this,
             handler:function(b){
               var it = b.findParentByType('panel').items.items;
               this.sendRequest({action:'insert', base:it[2].getValue(), dir:it[4].getValue()});
             }
            }
          ]
        };
    var insert1 = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:5},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            {width:80, text:'Insert Base(s) '},
            {width:50, xtype:'textfield', id:'iBase',
             validator:function(v){
               if(v.match(/^[ACGT]*$/i)) return true;
               else return "Only A/C/G/T are allowed";
             }},
            {xtype:'button',text:'Insert Now',scope:this,
             handler:function(b){
               var it = b.findParentByType('panel').items.items;
               this.sendRequest({action:'insertgap', base:it[2].getValue()});
             }
            }
          ]
        };
    var del = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:2},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            {
              xtype:'button',
              text:'Delete Base <span style="font-weight:bold;color:' + color[this.pos[2].toUpperCase()] + '">' + this.pos[2] + '</span> at ' + pos,
              scope:this,
              handler:function(b){
                this.sendRequest({action:'delete'});
              }
            }
          ]
        };
    var reject = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:2},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            {
              xtype:'button',
              text:'Reject Entire Sequence',
              scope:this,
              handler:function(b){
                var val = "Reason for rejection (optional)";
                BMS.AG.ML.Util.prompt('Warning', 'Are you sure you want to reject the sequence? After rejection, it will be removed from the view once this map is processed again.', function(b, t) {
                  if(b == 'ok')
                    this.sendRequest({action:'reject1',reason:t && t != val?t:''});
                }, this, false, val)
              }
            }
          ]
        };
    var trim = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:4},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            { width:110, text:'Trim All Bases to the '},
            { width:70, xtype:'combo', editable:false,
              triggerAction: 'all', mode: 'local',
              store: ['Left','Right']
            },
            {xtype:'button',text:'Trim Now',scope:this,
             handler:function(b){
               var it = b.findParentByType('panel').items.items;
               this.sendRequest({action:'trim', dir:it[2].getValue()});
             }
            }
          ]
        };
    var change = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:4},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            { width:85, text:'Change Base to ' },
            { width:50, xtype:'combo', editable:false,
              triggerAction: 'all', mode: 'local',
              tpl: new Ext.XTemplate('<tpl for="."><div class="x-combo-list-item" style="font-weight:bold;color:{[this.getColor(values.field1)]}">{field1}</div></tpl>', {
                     getColor: function(base) { return color[base] }
                   }),
              store: ['A','C','G','T']
            },
            {xtype:'button',text:'Change Now',scope:this,
             handler:function(b){
               var it = b.findParentByType('panel').items.items;
               this.sendRequest({action:'change', base:it[2].getValue()});
             }
            }
          ]
        };
    var comp = {
          layout: 'table',
          border: false,
          layoutConfig: {columns:11},
          defaults: {style:style},
          defaultType: 'label',
          items:[
            pad,
            {width:100, html:'Alter Base % for <span style="font-weight:bold;color:'+ color.A +'">A</span>:'},
            {width:35, xtype:'numberfield', value: comp['A'] || 0, style:'background-color:' + color.A + ';font-weight:bold;color:' + color.A},
            {width:18, html:'<span style="font-weight:bold;color:'+ color.C +'">C</span>:'},
            {width:35, xtype:'numberfield', value: comp['C'] || 0, style:'background-color:' + color.C + ';font-weight:bold;color:' + color.C},
            {width:18, html:'<span style="font-weight:bold;color:'+ color.G +'">G</span>:'},
            {width:35, xtype:'numberfield', value: comp['G'] || 0, style:'background-color:' + color.G + ';font-weight:bold;color:' + color.G},
            {width:18, html:'<span style="font-weight:bold;color:'+ color.T +'">T</span>:'},
            {width:35, xtype:'numberfield', value: comp['T'] || 0, style:'background-color:' + color.T + ';font-weight:bold;color:' + color.T},
            {xtype:'button',text:'Alter Now',scope:this,
             handler:function(b){
               var it = b.findParentByType('panel').items.items;
               var a = it[2].getValue(), c = it[4].getValue(),
                   g = it[6].getValue(), t = it[8].getValue();
               if(a+g+c+t == 100)
                 this.sendRequest({action:'alter', a:a, c:c, g:g, t:t});
               else
                 BMS.AG.ML.Util.alert('Error','A+C+G+T must equal to 100!');
             }
            }
          ]
        };
    if(seq == '-') items.push(insert1, trim, reject);
    else items.push(insert, del, change, comp, trim, reject);
    Ext.apply(this, {
      title: 'Edit ' + this.pos[2] + ' (ref:' + base + ') at ' + pos,
      items: items,
      bbar: new Ext.ux.StatusBar({
        iconCls: 'x-status-valid',
        text: 'Ready',
        defaultText: 'Ready',
        defaultIconCls: 'x-status-valid',
        items: [
          '-',
          {
            text: 'Details',
            scope: this,
            handler: function () {
              var msg = (this.statusLines)? this.statusLines.join('\n') : 'Ready to send edit requests';
              BMS.AG.ML.Util.alert('Info', msg);
            }
          }
        ]
      })
    });
    BMS.AG.ML.DynamicViewer.BaseEditor.superclass.initComponent.apply(this, arguments);
  },
  sendRequest: function(params)
  {
    params.pos = this.pos[0];
    params.rawindex = this.pos[1];
    params.id = this.track.id;
    params.edit = params.action;
    params.action = 'edit';
    params.agent = 'imb';
    try { params.srcid = this.traceimage.coords.source.vdbid; } catch(e) { }
    if(dynamicViewer && dynamicViewer.timestamp) params.timestamp = dynamicViewer.timestamp;
    var bar = this.getBottomToolbar();
    bar.showBusy();
    if(this.rootURL)
    {
      Ext.Ajax.request({
        scope: this,
        url: this.rootURL,
        callback: function(o,s,r) {
          if(s)
          {
            var res = Ext.decode(r.responseText), msgSrc = [];
            this.statusLines = [];
            if (msgSrc = res.error)
              bar.setStatus({text: 'Edit Error',
                iconCls: 'x-status-error',
                clear: true});
            else if (msgSrc = res.msg)
              bar.setStatus({text: 'Edit successful',
                iconCls: 'x-status-valid',
                clear: true});
            else
              bar.setStatus({text: 'Failed to recover information from database',
                iconCls: 'x-status-error',
                clear: true});
            for (var e = 0; e < msgSrc.length; e++)
              this.statusLines.push(msgSrc[e]);
          }
          else
            bar.setStatus({text: 'Failed to connect to the server!',
              iconCls: 'x-status-error',
              clear: true});
        },
        params: params
      });
    }
  }
});

Ext.reg("mv-editbase", BMS.AG.ML.DynamicViewer.BaseEditor);
