/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fix bug in Ext 3.2.1 (by reverting to 3.1.0 code)
Ext.override(Ext.data.JsonReader,
  {
    createAccessor : function(){
        var re = /[\[\.]/;
        return function(expr) {
            try {
                return(re.test(expr)) ?
                new Function('obj', 'return obj.' + expr) :
                function(obj){
                    return obj[expr];
                };
            } catch(e){}
            return Ext.emptyFn;
        };
    }()
  });
Ext.override(Ext.data.Store,
  {
    load: function(options) {
            options = options || {};
            this.storeOptions(options);
            if(this.sortInfo && this.remoteSort){
        var pn = this.paramNames;
        options.params = options.params || {};
        options.params[pn.sort] = this.sortInfo.field;
        options.params[pn.dir] = this.sortInfo.direction;
            }
            try {
        return this.execute('read', null, options);
            } catch(e) {
        this.handleException(e);
        return false;
            }
    }
  });

// fixes for bugs that take forever to be fixed by Extjs

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// the following workaround for z-index problems come from http://extjs.com/forum/showthread.php?p=183420
// tested bugs & fixes applicable to 2.2.1 - 3.0.2
Ext.form.ComboBox.prototype.initComponent = Ext.form.ComboBox.prototype.initComponent.createSequence( function(){
    this.on('expand', function(){ // I updated this fix for 3.2.1 (and it's still needed!)
            var win = Ext.WindowMgr.getActive(), zindex = win && win.el.dom.style && win.el.dom.style.zIndex? win.el.dom.style.zIndex - 0 + 10 : Ext.WindowMgr.zseed + 5000; // 5000 makes sure it shows up over shadow the 1st time
            this.list.setStyle("z-index", zindex.toString() );
        },
        this,
        {single: true}
    );
});

//put alert-Box on the top level (50001)
var _mb_alert = Ext.MessageBox.alert;
Ext.MessageBox.alert = function(){
    var zseed = Ext.WindowMgr.zseed;
    Ext.WindowMgr.zseed = 50005;
    var res = _mb_alert.apply( this, arguments );
    Ext.WindowMgr.zseed = zseed;
    return res;
}

//put windows (dialog) on the top level (49999)
var _w_show = Ext.Window.prototype.show;
Ext.Window.prototype.show = function(){
    var zseed = Ext.WindowMgr.zseed;
    Ext.WindowMgr.zseed = 49999;
    var res = _w_show.apply( this, arguments );
    Ext.WindowMgr.zseed = zseed;
    return res;
}

//put menu even higher, does not work yet
// var _m_show = Ext.menu.Menu.prototype.show;
// Ext.menu.Menu.prototype.show = function(){
//     var zseed = Ext.menu.MenuMgr.zseed;
//     Ext.menu.MenuMgr.zseed = 50001;
//     var res = _m_show.apply( this, arguments );
//     Ext.menu.MenuMgr.zseed = zseed;
//     return res;
// }

/////////////////////////////////////////////////////////////////////////////////
// below are some Ext bug fixes (or Gecko bug workaround)
// tested bugs & fixes applicable to 2.2.1 - 3.0.2
Ext.override(Ext.Element,
  {
    contains : function(el)
    {
      try
      {
        return !el ? false : Ext.lib.Dom.isAncestor(this.dom, el.dom ? el.dom : el);
      }
      catch(e)
      {
        return false;
      }
    }
  });
Ext.lib.Event.resolveTextNode = Ext.isGecko ? function(node){
	if(!node){
		return;
	}
	var s = HTMLElement.prototype.toString.call(node);
	if(s == '[xpconnect wrapped native prototype]' || s == '[object XULElement]'){
		return;
	}
	return node.nodeType == 3 ? node.parentNode : node;
} : function(node){
	return node && node.nodeType == 3 ? node.parentNode : node;
};

////////////////////////////////////////////////////////////////////////////////
// below allows Ext grid text to be selectable
if (!Ext.grid.GridView.prototype.templates) Ext.grid.GridView.prototype.templates = {};
Ext.grid.GridView.prototype.templates.cell = new Ext.Template(
   '<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} x-selectable {css}" style="{style}" tabIndex="0" {cellAttr}>',
   '<div class="x-grid3-cell-inner x-grid3-col-{id}" {attr}>{value}</div>',
   '</td>'
);