loggerViewer = function(conf)
{
  if(!conf) conf = {};
  var defConf =
    {
      forcefit: true,
      store: new Ext.data.ArrayStore(
        {
          autoDestroy: true,
          idIndex: 0,
          fields: [ 'idx', {name: 'type'}, {name: 'msg'} ]
        }),
      colModel: new Ext.grid.ColumnModel(
        {
          defaults: { sortable: true },
          columns:
            [
              {id: 'idx', header: 'Msg ID', width:50, dataIndex: 'idx'},
              {header: 'Type', width:80, dataIndex: 'type'},
              {header: 'Message', width:535, dataIndex: 'msg'}
            ]
        }),
      sm: new Ext.grid.RowSelectionModel(),
      height: 460,
      width: 677,
      tbar: [
        {
          text: 'Copy the Log',
          scope: logger,
          handler : logger.copy
        },
        {
          text: 'Reset the Log',
          scope: logger,
          handler : logger.reset
        }
      ]
    };
  Ext.apply(conf, conf, defConf);
  this.viewer = new Ext.grid.GridPanel(conf);
};
logger =
{
  msg: [],
  idx: 0,
  add: function(type, msg)
  {
    if(msg) this.msg.push([++this.idx, type, msg]);
  },
  write: function(returnViewer, viewerConf)
  {
    if(returnViewer)
    {
      var v = new loggerViewer(viewerConf);
      v.viewer.store.loadData(this.msg);
      this.viewer = v.viewer;
      return v.viewer;
    }
    else return this.msg;
  },
  reset: function(viewer)
  {
    this.msg = [];
    this.idx = 0;
    if(this.viewer) this.viewer.store.loadData(this.msg);
  },
  copy: function()
  {
    var str = new Array(), maxWidth = {idx:6, msg:7, type:4};
    for(var i = 0; i < this.msg.length; i++)
    {
      if(maxWidth.msg < this.msg[i][2]) maxWidth.msg = this.msg[i][2];
      if(maxWidth.type < this.msg[i][1]) maxWidth.type = this.msg[i][1];
    }
    for(var i = 0; i < this.msg.length; i++)
      str.push(String(this.msg[i][0]).pad(maxWidth.idx)+'\t'+this.msg[i][1].pad(maxWidth.type)+'\t'+this.msg[i][2].pad(maxWidth.msg));
    var w = new Ext.Window(
      {
        layout:'fit',
        title:'Copy and paste (e.g., into Excel)',
        width:500,
        height:300,
        plain: true,
        html:'<textarea class="fullseq" style="height:100%">Msg ID\tType\tMessage\n'+ str.join('\n') +'</textarea>'
      });
    w.show(this);
  }
};
