// Author: Mingyi Liu

String.prototype.pad = function(len, dir, c) // dir = 1 (left), 2 (both), 3 (right)
{
  if((len -= this.length) <= 0) return this;
  len++;
  c = c || ' ';
  dir = dir || 3;
  dir = dir == 1? len : dir == 3? 0: Math.floor(len / 2); // left length
  return new Array(dir).join(c) + this + new Array(len - dir).join(c);
};
BMS = function() { alert('Bristol-Myers Squibb!') }
BMS.AG = function() { alert('Applied Genomics!') }
BMS.AG.ML = function() { alert('Mingyi Liu!') }
BMS.AG.ML.Util = {
  useExtMsgBox: true, // set it to false to use javascript's default alert box
  autoAlertAjaxException: false, // set it to true to auto-alert user of failed ajax calls
  alertAjaxExceptionMsg: '', // set it to what HTML message you'd like to attach to the end of alert
                             //(like '<a href=mailto:mingyi.liu@bms.com>Email me</a> about the error')
                             // NOTE!! only applicable when you enable autoAlertAjaxException
  counters:{},
  
  // utility functions
  // for DOM element
  toggleClass: function(element, className)
  {
    if(element.className.match(className))
      this.removeClass(element, className);
    else this.addClass(element, className);
  },
  removeClass: function(element, className)
  {
    element.className = element.className.replace(new RegExp('(?:^|\\s+)' + className + '(?:\\s+|$)','ig'), ' ')
  },
  addClass: function(element, className)
  {
    if(!element.className.match(className)) element.className += ' ' + className;
  },
  getColor: function(color)
  {
    if(!color || color.length < 3) color = [255, 255, 255];
    return this.toColor16(color[0]) + this.toColor16(color[1]) + this.toColor16(color[2]);
  },
  toColor16: function(num)
  {
    if(num < 0) num = 0;
    else if(num > 255) num = 255;
    var t = num.toString(16);
    return (t.length > 1)? t : '0'+t;
  },
  // test if values are the same (value and type)
  sameObj: function(a, b)
  {
    if(a === b) return true;
    if(typeof(a) != 'object' || typeof(b) != 'object') return false;
    for(var p in a)
    {
      if(a[p] === b[p]) continue;
      if(b[p] === undefined || typeof(a[p]) != typeof(b[p])) return false;
      if(!this.sameObj(a[p], b[p])) return false;
    }
    for(var p in b)
      if(a[p] === undefined) return false;
    return true;
  },
  // don't forget in IE the element names in selector should be capitalized!!! (all HTML4 tags are converted below though)
  // note that selector does NOT allow array
  // opt: isNum, isColor
  getCSSRule: function(selector, ruleName, opt)
  {
    selector = (Ext.isIE)?
      selector.replace(/\b(a|abbr|acronym|address|applet|area|b|base|basefont|bdo|big|blockquote|body|br|button|caption|center|cite|code|col|colgroup|dd|del|dfn|dir|div|dl|dt|em|fieldset|font|form|frame|frameset|h1|head|hr|html|i|iframe|img|input|ins|kbd|label|legend|li|link|map|menu|meta|noframes|noscript|object|ol|optgroup|option|p|param|pre|q|s|samp|script|select|small|span|strike|strong|style|sub|sup|table|tbody|td|textarea|tfoot|th|thead|title|tr|tt|u|ul|var|isindex|xmp)\b/ig, function(s) { return s.toUpperCase()}) // '$1'.toUpperCase(), ('$1'+'')... do not work, '$1 a'.toUpperCase() would upper 'a' only! $1 const even when it's substr?
      :
      selector.replace(/\b(A|ABBR|ACRONYM|ADDRESS|APPLET|AREA|B|BASE|BASEFONT|BDO|BIG|BLOCKQUOTE|BODY|BR|BUTTON|CAPTION|CENTER|CITE|CODE|COL|COLGROUP|DD|DEL|DFN|DIR|DIV|DL|DT|EM|FIELDSET|FONT|FORM|FRAME|FRAMESET|H1|HEAD|HR|HTML|I|IFRAME|IMG|INPUT|INS|KBD|LABEL|LEGEND|LI|LINK|MAP|MENU|META|NOFRAMES|NOSCRIPT|OBJECT|OL|OPTGROUP|OPTION|P|PARAM|PRE|Q|S|SAMP|SCRIPT|SELECT|SMALL|SPAN|STRIKE|STRONG|STYLE|SUB|SUP|TABLE|TBODY|TD|TEXTAREA|TFOOT|TH|THEAD|TITLE|TR|TT|U|UL|VAR|ISINDEX|XMP)\b/ig, function(s) { return s.toLowerCase()});
    var rules = Ext.util.CSS.getRule(selector);
    if(rules && rules.style)
    {
      if(opt.isNum) return parseInt(rules.style[ruleName]);
      else if(opt.isColor)
      {
        var t = rules.style[ruleName];
        if(t && t.match(/(\d+),\s*(\d+),\s*(\d+)/))
          return [parseInt(RegExp.$1), parseInt(RegExp.$2), parseInt(RegExp.$3)];
        else {} // should we alert that it's not available or a number?
      }
      else return rules.style[ruleName];
    }
  },
  // it takes care of capitalized selector issue in IE then returns Ext.util.CSS.updateRule
  // note that selector does NOT allow array
  updateCSSRule: function(selector, ruleName, val)
  {
    selector = (Ext.isIE)?
      selector.replace(/\b(a|abbr|acronym|address|applet|area|b|base|basefont|bdo|big|blockquote|body|br|button|caption|center|cite|code|col|colgroup|dd|del|dfn|dir|div|dl|dt|em|fieldset|font|form|frame|frameset|h1|head|hr|html|i|iframe|img|input|ins|kbd|label|legend|li|link|map|menu|meta|noframes|noscript|object|ol|optgroup|option|p|param|pre|q|s|samp|script|select|small|span|strike|strong|style|sub|sup|table|tbody|td|textarea|tfoot|th|thead|title|tr|tt|u|ul|var|isindex|xmp)\b/ig, function(s) { return s.toUpperCase()}) // '$1'.toUpperCase(), ('$1'+'')... do not work, '$1 a'.toUpperCase() would upper 'a' only! $1 const even when it's substr?
      :
      selector.replace(/\b(A|ABBR|ACRONYM|ADDRESS|APPLET|AREA|B|BASE|BASEFONT|BDO|BIG|BLOCKQUOTE|BODY|BR|BUTTON|CAPTION|CENTER|CITE|CODE|COL|COLGROUP|DD|DEL|DFN|DIR|DIV|DL|DT|EM|FIELDSET|FONT|FORM|FRAME|FRAMESET|H1|HEAD|HR|HTML|I|IFRAME|IMG|INPUT|INS|KBD|LABEL|LEGEND|LI|LINK|MAP|MENU|META|NOFRAMES|NOSCRIPT|OBJECT|OL|OPTGROUP|OPTION|P|PARAM|PRE|Q|S|SAMP|SCRIPT|SELECT|SMALL|SPAN|STRIKE|STRONG|STYLE|SUB|SUP|TABLE|TBODY|TD|TEXTAREA|TFOOT|TH|THEAD|TITLE|TR|TT|U|UL|VAR|ISINDEX|XMP)\b/ig, function(s) { return s.toLowerCase()});
    return Ext.util.CSS.updateRule(selector, ruleName, val);
  },
  clone: function(obj)
  {
    if(!obj || typeof obj != 'object')
      return obj;
    var newObj = new obj.constructor();
    for (var p in obj)
      if (typeof obj[p] == 'object')
        newObj[p] = this.clone(obj[p]);
      else
        newObj[p] = obj[p];
    return newObj;
  },
  alert: function(title, msg)
  {
    if(!msg) { msg = title; title = 'Info'; } // allow passing just the msg
    if(this.useExtMsgBox) Ext.Msg.alert(title, msg);
    else alert(msg);
  },
  confirm: function(title, msg, fn, scope)
  {
    if(this.useExtMsgBox) Ext.Msg.confirm(title, msg, fn, scope);
    else fn.call(scope, confirm(msg)? 'yes':'no');
  },
  prompt: function(title, msg, fn, scope, ml, val)
  {
    if(this.useExtMsgBox) Ext.Msg.prompt(title, msg, fn, scope, ml, val);
    else
    {
      var t = prompt(msg, val || '');
      fn.call(scope, t == null? 'cancel':'ok', t);
    }
  },
  // calculate min,max,count,sum,med,avg,sd for array a, and store in hash k (return value is k)
  // array a will be sorted ascending!!!
  // avg will be used for sd calculation if passed in (useful for certain calculations)
  arrayStats: function(a, k, avg)
  {
    if(!k) k = {};
    if(a && a.length)
    {
      a.sort(function(a,b){return a-b});
      if(a.length == 1) k.med = a[0];
      else if(a.length % 2) k.med = a[Math.floor(a.length/2)];
      else k.med = (a[a.length/2-1]+a[a.length/2])/2;
      k.min = a[0];
      k.max = a[a.length - 1];
      k.sum = 0;
      for(var i = 0; i < a.length; i++)
        k.sum += a[i];
      k.avg = k.sum / a.length;
      k.count = a.length;
      var sum = 0;
      if(avg == null) avg = k.avg;
      for(var i = 0; i < a.length; i++)
        sum += Math.pow(a[i] - avg, 2);
      k.sd = (k.count == 1)? 0 : Math.sqrt(sum / (k.count - 1));
    }
    return k;
  },
  alertAjaxException: function(res, opt)
  {
    if(this.autoAlertAjaxException) // use Ext.Msg.alert makes sure if the tab's not active, it won't be activated by this alert
      Ext.Msg.alert('Ajax call failed!', 'Call to <a href="' + opt.url + '">' + opt.url + '</a> failed with:<div style="text-align:center;margin-top:10px;"><h3>Status: ' + res.status + ' (' + res.statusText + ')</h3></div>' + this.alertAjaxExceptionMsg);
  }
};

if(typeof(Ext) !== 'undefined')
{
  Ext.Ajax.on('beforerequest', function(con, opt){
    BMS.AG.ML.Util.hasAjaxException = false;
    if(!opt || !opt.url || !opt.url.match(/[\w.]{3,}/))
    {
      Ext.Msg.alert('Ajax call failed!', 'No valid URL found for the Ajax call!'); // better than using Ext's alert, which gets erased by later alert calls
      return false;
    }
    return true;
  });
  Ext.Ajax.on('requestexception', function(con, res, opt){
    BMS.AG.ML.Util.alertAjaxException(res, opt);
  });
}
