BMS.AG.ML.DynamicViewer.StatsGrid = Ext.extend(Ext.grid.GridPanel, {
  constructor: function(config) {
    // config should:
    //   have height, width, callback (optional) set
    //   also MUST have statsCallback to supply a stats obj (see commentManager)
    var useGroup = config.useGroup;
    Ext.apply(this, config, {
      title: useGroup? 'Group Stats' : 'Stats',
      store: new Ext.data.ArrayStore(
        {
          autoDestroy: true,
          idIndex: 0,
          fields: [
             'base',
             {name: 'count', type: 'float'},
             {name: 'min', type: 'float'},
             {name: 'max', type: 'float'},
             {name: 'med', type: 'float'},
             {name: 'sd', type: 'float'}
          ]
        }),
      colModel: new Ext.grid.ColumnModel(
        {
          defaults:
            {
              width: Math.floor(config.width / 6),
              sortable: true
            },
          columns:
            [
              {id: 'base', header: 'nt/aa', dataIndex: 'base'},
              {header: 'Count', dataIndex: 'count'},
              {header: 'Min %', dataIndex: 'min'},
              {header: 'Max %', dataIndex: 'max'},
              {header: 'Med %', dataIndex: 'med'},
              {header: 'SD', dataIndex: 'sd'}
            ]
        }),
      sm: new Ext.grid.RowSelectionModel(),
      tbar: config.callback? [
        {
          text: 'Filter to Selected nt/aa',
          scope: config.callback.scope,
          handler : config.callback.fn
        }
      ] : null
    });
    BMS.AG.ML.DynamicViewer.StatsGrid.superclass.constructor.call(this);
  }
});
Ext.reg("statsgrid", BMS.AG.ML.DynamicViewer.StatsGrid);