var imv = BMS.AG.ML.IMVConfig;
Ext.USE_NATIVE_JSON = imv.nativeJSON;
Ext.Updater.defaults.timeout = imv.cgiTimeout; // it takes a long time for the alignment to be generated dynamically, so let's set the timeout for a long time (default is only 30 seconds)
var dynamicViewer, viewControllerResize = false, initPath, initName, initGroup, win, currentUser;
var url = top.window.location.href, tracksOn = 'dnaprot', tracksMap = {};
BMS.AG.ML.Util.useExtMsgBox = imv.useExtMsgBox; // Ext's msgbox so slow with large DOM!

for(var i = 0; i < imv.defaultTracks.length; i++)
{
  tracksMap[imv.defaultTracks[i][1]] = imv.defaultTracks[i][0];
  tracksMap[imv.defaultTracks[i][0]] = imv.defaultTracks[i][0];
}

var p = {onReady:function(f){f()}};
if(imv.prefManagerURL)
{
  p = new Ext.ux.state.BMSProvider({appName:imv.appName,url:imv.prefManagerURL});
  Ext.state.Manager.setProvider(p);
}
BMS.AG.ML.Util.autoAlertAjaxException = true;

/////////////////////////////////////////////////////////////////////////////////////////////////
// create the UI
p.onReady(function()
{
  if(!url.match(/localhost/))
  {
    if(imv.userName) currentUser = imv.userName;
    else if(imv.prefManagerURL && (!p || !p.extraVals || !p.extraVals.BMSUser))
      BMS.AG.ML.Util.alert('Cannot confirm current user. Some comment operations will not work properly');
    else if(p.extraVals) currentUser = p.extraVals.BMSUser;
  }

  // let's check if we should load a test map right away (this must be before the get maps ajax call below!!!
  if(url.match(/path=([^&]+)/))
  {
    initPath = RegExp.$1;
    initName = url.match(/name=([^&]+)/)? RegExp.$1 : initPath;
    initGroup = url.match(/group=([^&]+)/)? RegExp.$1 : '';
  }
  if(url.match(/trace=([^&]+)/))
  {
    if(RegExp.$1 == 'off')
      BMS.AG.ML.IMVConfig.traceOff = true;
  }
  if(url.match(/tracksOn=([^&]+)/))
  {
    tracksOn = RegExp.$1;
    var newTracks = [];
    for(var i = 0; i < imv.defaultTracks.length; i++)
      if(tracksOn.indexOf(imv.defaultTracks[i][0]) > -1)
        newTracks.push(imv.defaultTracks[i]);
    imv.defaultTracks = newTracks;
  }

  // create dynamicViewer with the minimum required info
  dynamicViewer = new BMS.AG.ML.DynamicViewer({key:'vvConfig'},
    {
      controller: { renderTo: 'viewcontrol' },
      commentConf: commentObj,
      currentUser: currentUser,
      hasDNATrack: tracksOn.match(/dna/),
      logger: logger,
      finishedCallback: {fn:setTracksChecked}
    });

  // get maps ajax call
  if(imv.mapListAjax)
    Ext.Ajax.request({
      scope: this,
      url: imv.editURL,
      params: imv.mapListAjax.params,
      callback: mapCallback
    });
  else mapCallback(null, true, {});
});

function mapCallback(o,s,r){
  var westWidth = imv.westWidth;
  var westMaxWidth = imv.westMaxWidth || 500;
  var controllerDivHeight = imv.controllerDivHeight;
  var controllerDivMaxHeight = imv.controllerDivMaxHeight || 200;
  if(s)
  {
    ///////////////////////////////////////////////////////////////////////////////////////
    // first create the actual UI panel objs
    var headingPanel =
      {
        region: 'north',
        layout: 'border',
        items:[
          {
            region: 'west',
            layout: 'column',
            width: 365,
            items:[
              {
                width: westWidth,
                border: false,
                items: getMaps(imv.mapListAjax? imv.mapListAjax.callback(r.responseText) : imv.initMaps || '')
              },
              {
                width: 28,
                height: 15,
                border: false,
                style: 'font-size:11px;font-family:tahoma,arial,helvetica,sans-serif;margin:5px 0px 0px 5px;',
                html: 'Go to'
              },
              {
                border: false,
                xtype:'textfield',
                hideLabel:true,
                width: 40,
                id: 'vp_moveto',
                name: 'MoveTo',
                enableKeyEvents:true,
                style: 'margin:0px 0px 1px',
                listeners:{
                            keyup:function(t,e)
                            {
                              var v = t.getValue();
                              var tr = Ext.getCmp('vp_trackCombo').getValue();
                              if(v.match(/\S/) && tr && e.getKey() == Ext.EventObject.RETURN)
                               dynamicViewer.moveViewPosition(tracksMap[tr], v);
                            }
                          }
              },
              {
                width: 15,
                border: false,
                style: 'font-size:11px;font-family:tahoma,arial,helvetica,sans-serif;margin:5px 0px 0px 3px;',
                html: 'on'
              },
              {
                width: 68,
                xtype: 'combo',
                id: 'vp_trackCombo',
                displayField:'name',
                valueField:'track',
                store: new Ext.data.ArrayStore({
                         fields: ['track','name'],
                         data: imv.defaultTracks
                       }),
                typeAhead: true,
                mode: 'local',
                triggerAction: 'all',
                selectOnFocus:true,
                emptyText:'track',
                listeners:{ 'select': function(c){
                             var v = Ext.getCmp('vp_moveto').getValue();
                             if(v.match(/\S/)) dynamicViewer.moveViewPosition(tracksMap[c.getValue()], v);
                           } }
              }
            ]
          },
          {
            region: 'center',
            html: '<h1 class="x-panel-header" align="center">' + imv.headerTitle + '</h1>'
          }
        ],
        height: 25,
        border: false,
        margins: '0 0 5 0'
      };
    var mutOverviewPanel =
      {
        region: 'north',
        split: viewControllerResize,
        stateful: viewControllerResize,
        title: 'Mutation Overview',
        id: 'vp_mutOverview',
        height: controllerDivHeight + 26, // header is 26 px high
        minHeight: controllerDivHeight + 26,
        maxHeight: controllerDivMaxHeight + 26,
        listeners: viewControllerResize? { bodyresize: dynamicViewer.viewController.updateView, scope: dynamicViewer.viewController } : {},
        html: '<div id="viewcontrol" class="viewerController"></div>'
      };
    var trackSelectPanel =
      {
        xtype: 'fieldset',
        title: 'Displayed Tracks',
        style:((Ext.isIE)?'padding:0px 10px 0px 20px;height:48px':'padding:5px 10px 5px 20px;height:35px')+';margin-bottom:1px',
        width: westWidth - 3,
        items:
        {
          id: 'vp_dispTracks',
          xtype: 'checkboxgroup',
          hideLabel: true,
          columns: 2,
          items:
          [
            // had to use a hack to avoid Ext.2.2.1 bug that fires 'check' while rendering
            {boxLabel: 'DNA', name: 'dna', checked: tracksOn.match(/dna/), disabled: !tracksOn.match(/dna/),
            listeners:{ render : function(a,b,c) { this.on('check',trackChanged) } } },
            {boxLabel: 'Protein', name: 'prot', checked: tracksOn.match(/prot/), disabled: !tracksOn.match(/prot/),
            listeners:{ render : function(a,b,c) { this.on('check',trackChanged) } } }
          ]
        }
      };
    var optionTreePanel =
      {
        xtype: 'treepanel',
        title: 'Options & Actions',
        height: imv.optionsPanelHeight,
        autoScroll: true,
        collapsed: false,
        collapsible: true,
        loader: new Ext.tree.TreeLoader(),
        root: new Ext.tree.AsyncTreeNode({
            expanded: true,
            children: [
              {
                text: 'Current View Actions',
                leaf: false,
                expanded: true,
                children:[
                  { text: 'Right', leaf: true },
                  { text: 'Left', leaf: true },
                  {
                    text: 'Other',
                    leaf: false,
                    expanded: BMS.AG.ML.IMVConfig.otherOptionsExpanded,
                    children: [
                      { text: 'Refresh Current View', leaf: true },
                      { text: 'Reset View Settings', leaf: true },
                      {
                        text: 'Move',
                        leaf: false,
                        expanded: true,
                        children:[
                          { text: 'Up', leaf: true },
                          { text: 'Down', leaf: true }
                        ]
                      },
                      {
                        text: 'Zoom',
                        leaf: false,
                        expanded: true,
                        children:[
                          { text: 'In', leaf: true },
                          { text: 'Out', leaf: true }
                        ]
                      },
                      {
                        text: 'History',
                        leaf: false,
                        expanded: true,
                        children:[
                          { text: 'Back', leaf: true },
                          { text: 'Forward', leaf: true }
                        ]
                      }
                    ]
                  }
                ]
              },
              {
                text: 'Application Options',
                leaf: false,
                expanded: BMS.AG.ML.IMVConfig.otherOptionsExpanded,
                children:[
                  { text: 'Toggle Crosshair', leaf: true },
                  { text: 'Toggle Popup Mode', leaf: true },
                  { text: 'Toggle Separators', leaf: true }
                ]
              },
              { text: 'Stat/Seq for Positions', leaf: true },
              { text: 'Export Alignment', leaf: true },
              { text: 'Export Sequences', leaf: true },
              { text: 'Show Session Log', leaf: true }
            ]
          }),
        rootVisible: false,
        listeners: { click: processOptions }
      };
    var filterPanel = {border: false};
    if(imv.filterPanel && imv.filterPanel.items)
    {
      var filterBoxDefaults = {labelStyle:'font-size:11px;width:' + imv.filterPanel.labelWidth + 'px;',style:'margin:1px;'};//labelStyle prevents labelWidth to work; margin here prevent IE to cut off the bottom of the input textbox
      if(viewControllerResize) filterBoxDefaults.anchor = '99%';
      else filterBoxDefaults.width = imv.filterPanel.boxWidth;
      var fItems = [], aItem = 0;
      for(var i = 0; i < imv.filterPanel.items.length; i++)
      {
        var j = imv.filterPanel.items[i];
        if(j.active) aItem = i;
        if(j.mutationFilter)
        {
          fItems.push({
            title:'Mutation Filters',
            id:'vp_ff',
            layout:'form',
            defaultType: 'textfield',
            defaults:filterBoxDefaults,
            items: [
              { fieldLabel: 'Top mutation %', id: 'mut', name: 'Top mutation %' },
              { fieldLabel: 'Min mutation %', id: 'mmut', name: 'Min mutation %' },
              { fieldLabel: 'Min group SD', id: 'pmut', name: 'Min group SD' }
            ],
            listeners:
            { expand: filterObj.createFormTips, scope: filterObj }
          });
        }
        else if(j.fields && j.fields.length)
        {
          var fields = [], id = 'vp_' + j.title.replace(/\W+/g, '_');
          filterObj.fieldIds[j.title] = [];
          for(var k = 0; k < j.fields.length; k++)
          {
            var f = j.fields[k], fo = { fieldLabel: f.label, id: f.id, name: f.name };
            if(f.type == 'number')
            {
              fo.validator = filterObj.validateNum;
              filterObj.fieldTypes[f.name] = 'number';
            }
            else filterObj.fieldTypes[f.name] = 'text';
            if(f.tip) filterObj.helpStrings[f.id] = f.tip;
            filterObj.fieldIdNames[f.id] = f.name;
            filterObj.fieldIds[j.title].push(f.id);
            fields.push(fo);
          }
          fItems.push({
            title: j.title,
            id: id,
            layout: 'form',
            defaultType: 'textfield',
            bodyStyle: 'padding:3px',
            defaults: filterBoxDefaults,
            items: fields,
            listeners:
            { expand: filterObj.createFormTips, scope: filterObj }
          });
        }
      }
      filterPanel = {
        region: 'center',
        title: 'Filters',
        id: 'vp_filter',
        border: false,
        collapsed: false,
        collapsible: true,
        items: {
          id: 'filters',
          xtype: 'form',
          layout: 'accordion',
          activeItem: aItem,
          defaults: {autoHeight:true, bodyStyle:'padding:5px'},
          items: fItems,
          buttonAlign:'center',
          buttons: [
            { text: 'Apply', handler: filterObj.submitFilters, scope: filterObj },
            {
              text: 'Reset', id: 'reset', tooltip: 'No filters applied',
              handler: function()
              {
                Ext.ComponentMgr.get('filters').getForm().reset();
                if(filterObj.button)
                  filterObj.tooltip = filterObj.button.setTooltip('No filters applied');
                dynamicViewer.resetFilters();
                logger.add('Action','Reset Filters')
              }
            }
          ]
        }
      };
    }
    //////////////////////////////////////////////////////////////////////////
    // now create the entire UI - application viewport
    new Ext.Viewport(
      {
        layout: 'border',
        items: [
          headingPanel, // north
          {
            region: 'west',
            width: westWidth,
            minWidth: westWidth,
            maxWidth: westMaxWidth,
            id: 'vp_west',
            layout: 'border',
            stateful: viewControllerResize,
            split: viewControllerResize,
            items: [
              mutOverviewPanel, // north
              {
                region: 'center',
                listeners: viewControllerResize? { bodyresize: panelResize } : {},
                items: [ trackSelectPanel, optionTreePanel, filterPanel ]
              }
            ]
          },
          {
            region: 'center',
            minWidth: 800,
            autoScroll: true,
            listeners: { bodyresize: dynamicViewer.resetMapSize, scope: dynamicViewer },
            html: '<div id="divmap" class="divmap"><div class="x-tip-body" style="text-align:center;font:11px,verdana,sans-serif;">Please choose a map to view using the dropdown menu at the upper left corner</div></div>' // id stipulated by dynamicViewer
          }
        ]
      }
    );
    new Ext.ToolTip({
      target: 'vp_moveto',
      dismissDelay: 0,
      mouseOffset: [15, -5],
      html: 'Allowed input:"213,4-42-BL-N1", "213" or "213,45" - where 213 is horizontal (gapped) sequence position; 4-42-BL-N1 is sample name;45 is vertical (sample) position; Session log could tell you exact what positions you are viewing now in the sequence X sample space'
    });
    if(filterPanel.id)
    {
      new Ext.ToolTip({
        target: Ext.getCmp('vp_filter').header,
        dismissDelay: 0,
        mouseOffset: [15, -120],
        html: 'The section below allows you to filter the view to only samples of interest. Each filter field will be applied to specific data in each sample - if you hold your mouse over a field, more information will be provided. If you provide multiple filters, only samples meeting <i>all</i> filters will be shown.<br><br>Filters on text data are case-insensitive, and will be based on partial matching, so <b>rat</b> will match "rat", "rate", "ratify" and "brown rat".<br><br>For numeric data, providing a simple number (eg 2, 2.31 or -3434.13) will match <i>exactly</i> that number. You can use greater/less than symbols to expand the match: <b>&gt;= 3</b> will match all values of 3 or greater, <b>&lt;99</b> will match values less than 99.<br><br>Within text field, you can provide multiple test cases using <b>|</b> to concatenate the cases you want (it is basically a regular expression search using the text string you sent in); while in number field, you could use <b>&amp;</b> ("and") and <b>|</b> ("or") - for now, you can not mix both. For example, <b>&gt;=5 &amp; &lt;=10</b> will match any numeric value between 5 and 10; <b><1| 5|=7|>9</b> gets anything equal to 5, 7, or greater than 9 or less than 1. <b>(<1&amp; >0.5)|<0.1</b> is not valid as paranthesis and mixing | and &amp; is not supported yet'
      });
      Ext.get('filters').on('keyup', function(e)
                               {
                                 if(e.getKey() == Ext.EventObject.RETURN)
                                   filterObj.submitFilters()
                               });
    }
    // initiate the main viewer
    Ext.EventManager.on(dynamicViewer.boundingDiv.id,
      {
        'click':{ fn:dynamicViewer.clearToolTips,scope:dynamicViewer },
        'mouseover':{ fn:dynamicViewer.toggleCellHiLite,scope:dynamicViewer },
        'mousemove':{ fn:dynamicViewer.moveCross,scope:dynamicViewer },
        'mouseout':{ fn:dynamicViewer.toggleCellHiLite,scope:dynamicViewer }
      });
    if(initPath) updateMap(null, {data:{name:initName, url:initPath, group:initGroup}}, null);
  }
  else
    BMS.AG.ML.Util.alert('Server Error', 'Cannot connect to server. Nothing can be displayed!');
}

function displayHint(e)
{
  var el = e.target;
  var c = commentObj.getComVals(filterObj.fieldIdNames[el.id]);
  clearWindow();
  win = new Ext.Window({
        title: 'MultiSelect Current Values',
        applyTo: 'window',
        closable:true,
        width:550,
        height:500,
        plain:true,
        html:'<form id="multiform" onsubmit="return sendSelections(\'' + el.id + '\')"><input value="Add Selection(s) to Filter" type="submit" class="buttons"><input value="Reset" type="reset" class="buttons"><input value="Clear \'' + el.name + '\' Filter" onclick="Ext.getCmp(\'' + el.id + '\').setValue(\'\')" type="button" class="buttons"><br><select id="multifilter" class="multifilter" multiple>\n  <option>' + c.join('</option>\n  <option>') + '</option>\n</select>'
  });
  win.center();
  win.show();
}
function sendSelections(id)
{
  var sel = Ext.get('multifilter').dom.options, f = Ext.getCmp(id);
  var str = f.getValue(), res = new Array();
  if(str) res.push(str);
  for(var i = 0; i < sel.length; i++)
    if(sel[i].selected) res.push(sel[i].text);
  f.setValue(res.join('|'));
  win.close();
  f.suspendEvents();
  f.focus();
  f.resumeEvents();
  return false;
}
function clearWindow()
{
  if(win) { win.close(); win = undefined; }
  Ext.get('windows').dom.innerHTML = '<div id="window"></div>';
}
function resetView(button)
{
  if(button == 'no') return;
  // we need to reset interface element as well
  var group = Ext.getCmp('vp_dispTracks');
  var trackChanged = false;
  for(var i = 0; i < group.items.items.length; i++)
    if(!group.items.items[i].checked)
      { trackChanged = true; Ext.getCmp(group.items.items[i].id).setValue(true); }
  dynamicViewer.stateManager.resetState(trackChanged);
  logger.add('Action', 'Reset viewer settings');
}
function processOptions(n)
{
  if(n.text == 'Right' || n.text == 'Left' || n.text == 'Up' || n.text == 'Down')
    dynamicViewer.moveView(n.text);
  else if(n.text == 'Reset View Settings' && dynamicViewer.data)
    BMS.AG.ML.Util.confirm('Reset Current View Settings',
      'The default view will be loaded after setting is reset, OK to proceed?',
      resetView);
  else if(n.text == 'Refresh Current View')
    dynamicViewer.refreshView();
  else if(n.text == 'Toggle Crosshair')
    dynamicViewer.toggleCross();
  else if(n.text == 'Toggle Popup Mode')
    dynamicViewer.togglePopup();
  else if(n.text == 'Toggle Separators')
    dynamicViewer.toggleSeparators();
  else if(n.text == 'Back')
    dynamicViewer.stateManager.backHistory();
  else if(n.text == 'Forward')
    dynamicViewer.stateManager.forwardHistory();
  else if(n.text == 'In' || n.text == 'Out')
    dynamicViewer.zoomView(n.text);
  else if(n.text == 'Show Session Log')
  {
    clearWindow();
    win = new Ext.Window({
          title: 'Session Log',
          applyTo: 'window',
          closable:true,
          width:700,
          height:500,
          plain:true,
          autoScroll:true,
          items: logger.write(true)
    });
    win.center();
    win.show();
  }
  else if(n.text == 'Export Alignment' || n.text == 'Export Sequences')
  {
    var seqs = dynamicViewer.trackManager.exportSeqs((n.text == 'Export Alignment')? 'align' : 'fasta');
    clearWindow();
    win = new Ext.Window({
          title: 'Sequence Alignments',
          applyTo: 'window',
          closable: true,
          width: 700,
          height: 500,
          plain:true,
          sequences: seqs,
          fbar: ['->',{
            text: 'Import DNA into VNTI',
            handler: getNTI
          },{
            text: 'Import Protein into VNTI',
            handler: getNTI
          }],
          html:'<textarea class="fullseq" style="height:100%">'+ seqs +'</textarea><form name="hiddenform" method="POST" action="http://bioinformatics.bms.com/biocgi/pl-shared/f2nti.pl"><input type="hidden" name="type" /><input type="hidden" name="seq" /></form>'
    });
    win.center();
    win.show();
    logger.add('Action', n.text);
  }
  else if(n.text == 'Stat/Seq for Positions')
  {
    clearWindow();
    var height = 400, width = 480;
    win = new Ext.Window({
          title: 'Stats and Sequences for User-Input Positions',
          applyTo: 'window',
          closable: true,
          width: width,
          height: height,
          resizable: false,
          plain: true,
          items: {
            xtype: 'statswizard',
            viewer: dynamicViewer,
            totalHeight: height - 34,
            totalWidth: width - 16
          }
    });
    win.center();
    win.show();
    logger.add('Action', n.text);
  }
}
function getNTI(b, e)
{
  var win = b.findParentByType('window'), seqs = win.sequences.split('\n\n\n'),
      dna = seqs[0], prot = seqs[1], seq, type, form = win.body.dom.childNodes[1];
  if(b.text.match(/DNA/))
  {
    seq = dna;
    type = 'dna';
  }
  else
  {
    type = 'prot';
    seq = prot || dna;
  }
  // do the request
  form.seq.value = seq;
  form.type.value = type;
  form.submit();
}
function trackChanged(e, checked)
{
  var group = Ext.getCmp('vp_dispTracks');
  if(!e.checked)
  {
    // sanity check
    var allHide = true;
    for(var i = 0; i < group.items.items.length; i++)
      if(group.items.items[i].checked)
        { allHide = false; break; }
    if(allHide)
    {
      e.suspendEvents();
      e.setValue(true);
      e.resumeEvents();
      BMS.AG.ML.Util.alert('Track Selections', 'Sorry, something has to be displayed!');
      return;
    }
  }
  dynamicViewer.showTrack(e.getName(), checked);
}
function getMaps(arr)
{
  var data = new Array();
  if(initPath) data.push([initName, initPath, initGroup]);
  if(arr)
    for(var i = 0; i < arr.length; i++)
      data.push(arr[i]);
  var store = new Ext.data.ArrayStore({
      fields: ['name','url','group'],
      data: data
  });
  return new Ext.form.ComboBox({
      store: store,
      width: 180,
      displayField:'name',
      typeAhead: true,
      mode: 'local',
      triggerAction: 'all',
      emptyText:'Select a Map to View ...',
      selectOnFocus:true,
      listeners:{ 'select': updateMap }
  });
}
function updateMap(c,r,i)
{
  dynamicViewer.removeAll();
  dynamicViewer.setCookieKey(r.data.name); // cookie should match map
  dynamicViewer.initState();
  dynamicViewer.dataurl = r.data.url; // where to send ajax calls for map data
  dynamicViewer.dataparam = {group:r.data.group};// !!! if we change data structure here, change stateManager.encodeValue etc. too
  dynamicViewer.getDataDisplay();
  var conf = dynamicViewer.stateManager.config;
  logger.add('Action', 'Loaded map \'' + r.data.name + '\' at ' + r.data.url + (r.data.group? ' group:' + r.data.group : ''));
}
function setTracksChecked()
{
  var group = Ext.getCmp('vp_dispTracks');
  var itms = group.items.items;
  for(var i = 0; i < itms.length; i++)
  {
    if(tracksOn.indexOf(itms[i].name) > -1)
    {
      itms[i].suspendEvents();
      itms[i].setValue(dynamicViewer.stateManager.config.displayTracks[itms[i].name].show); // .checked = true doesn't put a checkmark in the box (although it does in reality changed the state of the checkbox to checked)!
      itms[i].resumeEvents();
    }
  }
  var trackCombo = Ext.getCmp('vp_trackCombo');
  var data = new Array();
  for(var i = 0; i < imv.defaultTracks.length; i++)
    if(dynamicViewer.stateManager.config.displayTracks[imv.defaultTracks[i][0]].show)
      data.push(imv.defaultTracks[i]);
  trackCombo.getStore().loadData(data);
  if(data.length == 1) trackCombo.setValue(data[0][1]);
  trackCombo.collapse();
}
function panelResize()
{
  for(var i in {'vp_csf':1,'vp_clin':1,'vp_other':1,'vp_dispTracks':1})
    Ext.getCmp(i).fireEvent('resize');
}