BMS.AG.ML.IMVConfig = {
//   currentUser: , // this one's important for comment and preference storage!! Could be set by your script
  // editURL is required for trace image edits
  editURL: '/URL/path/cgi-bin/CGIs/empty.pl',
  headerTitle: 'Interactive Virus Mutation Viewer',
  westWidth: 200, // width of the left side panels
  controllerTitle: 'Mutation Overview',
  controllerDivHeight: 100, // height of the overview controller's panel
  optionsPanelHeight: 171, // height of the options treepanel
  otherOptionsExpanded: false, // load the 'Other' branch expanded in the Options treepanel
  appOptionsExpanded: false, // load the 'Application Options' branch expanded in the Options treepanel
  nativeJSON: true, // use browser's native JSON parser where available (very useful!!)
  cgiTimeout: 1000, // if backend cgi processing of alignment takes long, use 1000 seconds for ajax timeout
  defaultTracks: [['dna','DNA'],['prot','Protein']],
  useExtMsgBox: false, // true to use Ext's alert instead of browser's. Ext's alert is very slow for large maps due to masking
  westMaxWidth: 500, // unused now
  controllerDivMaxHeight: 200, // unused now

  // more involved config options
  prefManagerURL: '/URL/path/cgi-bin/CGIs/empty.pl', // a web service URL that takes prefManager Ajax calls to store user's view pref
  appName: 'mutationViewer', // identifier used for prefManager
  traceOff: false, // true to turn off trace panel in comment Panel
  mapListAjax: null, // dynamically retrieve list of maps, take 'param' and 'callback' (callback gets the response text as sole parameter)
  initMaps: [
    ['Demo static file', 'SampleJson-NS5A-1a.Boca.Pop.json', '']
  ],
  filterPanel: { // could be omitted
    labelWidth: 85,
    boxWidth: 70,
    items: [
      {
        title: 'CSF',
        fields: [
          {
            label: 'Requisition', id: 'req', name: 'Requisition',
            tip: 'The CSF Requisition ID, for example RQ-20100105-00005. Entering a value will show only those samples where the requisition matches your request'
          },
          {
            label: 'Mixed Locations', id: 'mixloc', name: 'Mixed Locations', type: 'number',
            tip: 'The number of mixed (polymorphic) sites automatically predicted in a sequence. Setting a value of ">=10", for example, will only show samples that have at least 10 mixed locations predicted'
          }
        ]
      },
      {
        title: 'Clinical',
        active: true,
        fields: [
          { label: 'Subject', id: 'subject', name: 'ClinicalSubject', tip: 'Patient ID'},
          { label: 'Sample Desc', id: 'clindesc', name: 'SampleDescription' },
          { label: 'Time Point', id: 'timepnt', name: 'ClinicalTimePoint', tip: 'Clinical Time Point' }
        ]
      },
      {
        title: 'Other',
        fields: [
          { label: 'User', id: 'user', name: 'User', tip: 'Your Windows Username' },
          { label: 'Comment', id: 'com', name: 'Comment' }
        ]
      },
      {
        mutationFilter: true
      }
    ]
  }
};